#!/usr/bin/perl -w

use strict;

#my $MIN_TIME = 3000;
#my $MAX_TIME = 3500;

#my $MIN_TIME = 3000;
#my $MAX_TIME = 9000;

my $MIN_TIME = 3000;
my $MAX_TIME = 3025;

my $nthreads = -1;

my $str = "";

my $infn;
if ($ARGV[0]) {
    $infn = $ARGV[0];
} else {
    $infn = "hourglass.out";
}

open INF, "<$infn" or die;

while (my $line = <INF>) {

    if ($line =~ /^numthreads: ([0-9]+)$/) {
	$nthreads = $1;
    }

    if ($line =~ /^tracerec: ([0-9]+) ([0-9\.]+) ([0-9\.]+) [0-9\.]+ [0-9\.]+$/) {
	
	my $thread = $1;
	my $start = $2;
	my $end = $3;
	
	next if ($end < $MIN_TIME);
	next if ($start > $MAX_TIME);

	if ($start < $MIN_TIME) {
	    $start = $MIN_TIME;
	}

	if ($end > $MAX_TIME) {
	    $end = $MAX_TIME;
	}

	my $nthread = $thread+1;
		
	$str .= "newline poly linethickness 0.5 pfill 0.8 pts\n";
	$str .= "  $start $thread\n";
	$str .= "  $end $thread\n";
	$str .= "  $end $nthread\n";
	$str .= "  $start $nthread\n\n";
    }
}

open OUTF, ">$infn.jgr" or die;

print OUTF "newgraph\n";
print OUTF "xaxis size 2.5 label fontsize 9 : Time (ms)\n";
print OUTF "yaxis size 1.0 label fontsize 9 : Thread Number\n";
print OUTF "  min 0\n";
print OUTF "  max $nthreads\n";
print OUTF "  hash 0\n";

for (my $i=0; $i<$nthreads; $i++) {
    print OUTF "  hash_label at ".($i+0.5)." : $i\n";
}

print OUTF $str;

close OUTF;

system "jgraph < $infn.jgr > $infn.eps";
system "jgraph -P -L < $infn.jgr > $infn.ps";
